package osvscanner

import (
	"reflect"
	"testing"

	"github.com/google/osv-scanner/internal/osv"
	"github.com/google/osv-scanner/internal/output"
	"github.com/google/osv-scanner/pkg/config"
	"github.com/google/osv-scanner/pkg/models"
)

func Test_groupResponseBySource(t *testing.T) {
	type args struct {
		r             *output.Reporter
		query         osv.BatchedQuery
		resp          *osv.HydratedBatchedResponse
		configManager *config.ConfigManager
	}
	tests := []struct {
		name string
		args args
		want models.VulnerabilityResults
	}{}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if got := groupResponseBySource(tt.args.r, tt.args.query, tt.args.resp); !reflect.DeepEqual(got, tt.want) {
				t.Errorf("groupResponse() = %v, want %v", got, tt.want)
			}
		})
	}
}
